GNU Radio C++ API Reference: WaterfallDisplayPlot Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
WaterfallDisplayPlot Class Reference
GNU Radio C++ Signal Processing Blocks » QT Graphical Interfaces

QWidget for displaying waterfall (spectrogram) plots. More...

`#include <gnuradio/qtgui/WaterfallDisplayPlot.h>`

## Public Slots
void | setIntensityColorMapType (const unsigned int, const int, const QColor, const QColor)
void | setIntensityColorMapType1 (int)
void | setColorMapTitleFontSize (int tfs)
void | setUserDefinedLowIntensityColor (QColor)
void | setUserDefinedHighIntensityColor (QColor)
void | setPlotPosHalf (bool half)
void | disableLegend () override
void | enableLegend ()
void | enableLegend (bool en)
void | setNumRows (int nrows)
Public Slots inherited from DisplayPlot
virtual void | disableLegend ()
virtual void | setAxisLabels (bool en)
virtual void | setYaxis (double min, double max)
virtual void | setXaxis (double min, double max)
virtual void | setLineLabel (unsigned int which, QString label)
virtual QString | getLineLabel (unsigned int which)
virtual void | setLineColor (unsigned int which, QColor color)
virtual QColor | getLineColor (unsigned int which) const
virtual void | setLineWidth (unsigned int which, int width)
virtual int | getLineWidth (unsigned int which) const
virtual void | setLineStyle (unsigned int which, Qt::PenStyle style)
virtual Qt::PenStyle | getLineStyle (unsigned int which) const
virtual void | setLineMarker (unsigned int which, QwtSymbol::Style marker)
virtual QwtSymbol::Style | getLineMarker (unsigned int which) const
virtual void | setMarkerAlpha (unsigned int which, int alpha)
virtual int | getMarkerAlpha (unsigned int which) const
void | setLineColor1 (QColor)
void | setLineColor2 (QColor)
void | setLineColor3 (QColor)
void | setLineColor4 (QColor)
void | setLineColor5 (QColor)
void | setLineColor6 (QColor)
void | setLineColor7 (QColor)
void | setLineColor8 (QColor)
void | setLineColor9 (QColor)
void | setLineWidth1 (int)
void | setLineWidth2 (int)
void | setLineWidth3 (int)
void | setLineWidth4 (int)
void | setLineWidth5 (int)
void | setLineWidth6 (int)
void | setLineWidth7 (int)
void | setLineWidth8 (int)
void | setLineWidth9 (int)
void | setLineStyle1 (Qt::PenStyle)
void | setLineStyle2 (Qt::PenStyle)
void | setLineStyle3 (Qt::PenStyle)
void | setLineStyle4 (Qt::PenStyle)
void | setLineStyle5 (Qt::PenStyle)
void | setLineStyle6 (Qt::PenStyle)
void | setLineStyle7 (Qt::PenStyle)
void | setLineStyle8 (Qt::PenStyle)
void | setLineStyle9 (Qt::PenStyle)
void | setLineMarker1 (QwtSymbol::Style)
void | setLineMarker2 (QwtSymbol::Style)
void | setLineMarker3 (QwtSymbol::Style)
void | setLineMarker4 (QwtSymbol::Style)
void | setLineMarker5 (QwtSymbol::Style)
void | setLineMarker6 (QwtSymbol::Style)
void | setLineMarker7 (QwtSymbol::Style)
void | setLineMarker8 (QwtSymbol::Style)
void | setLineMarker9 (QwtSymbol::Style)
void | setMarkerAlpha1 (int)
void | setMarkerAlpha2 (int)
void | setMarkerAlpha3 (int)
void | setMarkerAlpha4 (int)
void | setMarkerAlpha5 (int)
void | setMarkerAlpha6 (int)
void | setMarkerAlpha7 (int)
void | setMarkerAlpha8 (int)
void | setMarkerAlpha9 (int)
void | setZoomerColor (QColor c)
void | setPaletteColor (QColor c)
void | setAxisLabelFontSize (int axisId, int fs)
void | setYaxisLabelFontSize (int fs)
void | setXaxisLabelFontSize (int fs)
void | setAxesLabelFontSize (int fs)
void | setStop (bool on)
void | resizeSlot (QSize *s)
void | onPickerPointSelected (const QPointF &p)

## Signals
void | updatedLowerIntensityLevel (const double)
void | updatedUpperIntensityLevel (const double)
Signals inherited from DisplayPlot
void | plotPointSelected (const QPointF p)

## Public Member Functions
| WaterfallDisplayPlot (int nplots, QWidget *)
| ~WaterfallDisplayPlot () override
void | resetAxis ()
void | setFrequencyRange (const double, const double, const double units=1000.0, const std::string &strunits="kHz")
double | getStartFrequency () const
double | getStopFrequency () const
void | plotNewData (const std::vector< const double * > dataPoints, const int64_t numDataPoints, const double timePerFFT, const gr::high_res_timer_type timestamp, const int droppedFrames)
void | plotNewData (const double *dataPoints, const int64_t numDataPoints, const double timePerFFT, const gr::high_res_timer_type timestamp, const int droppedFrames)
void | setIntensityRange (const double minIntensity, const double maxIntensity)
double | getMinIntensity (unsigned int which) const
double | getMaxIntensity (unsigned int which) const
void | replot (void) override
void | clearData ()
int | getIntensityColorMapType (unsigned int) const
int | getIntensityColorMapType1 () const
int | getColorMapTitleFontSize () const
const QColor | getUserDefinedLowIntensityColor () const
const QColor | getUserDefinedHighIntensityColor () const
int | getAlpha (unsigned int which)
void | setAlpha (unsigned int which, int alpha)
int | getNumRows () const
Public Member Functions inherited from DisplayPlot
| DisplayPlot (int nplots, QWidget *)
| ~DisplayPlot () override
const QColor | getLineColor1 () const
const QColor | getLineColor2 () const
const QColor | getLineColor3 () const
const QColor | getLineColor4 () const
const QColor | getLineColor5 () const
const QColor | getLineColor6 () const
const QColor | getLineColor7 () const
const QColor | getLineColor8 () const
const QColor | getLineColor9 () const
int | getLineWidth1 () const
int | getLineWidth2 () const
int | getLineWidth3 () const
int | getLineWidth4 () const
int | getLineWidth5 () const
int | getLineWidth6 () const
int | getLineWidth7 () const
int | getLineWidth8 () const
int | getLineWidth9 () const
Qt::PenStyle | getLineStyle1 () const
Qt::PenStyle | getLineStyle2 () const
Qt::PenStyle | getLineStyle3 () const
Qt::PenStyle | getLineStyle4 () const
Qt::PenStyle | getLineStyle5 () const
Qt::PenStyle | getLineStyle6 () const
Qt::PenStyle | getLineStyle7 () const
Qt::PenStyle | getLineStyle8 () const
Qt::PenStyle | getLineStyle9 () const
QwtSymbol::Style | getLineMarker1 () const
QwtSymbol::Style | getLineMarker2 () const
QwtSymbol::Style | getLineMarker3 () const
QwtSymbol::Style | getLineMarker4 () const
QwtSymbol::Style | getLineMarker5 () const
QwtSymbol::Style | getLineMarker6 () const
QwtSymbol::Style | getLineMarker7 () const
QwtSymbol::Style | getLineMarker8 () const
QwtSymbol::Style | getLineMarker9 () const
int | getMarkerAlpha1 () const
int | getMarkerAlpha2 () const
int | getMarkerAlpha3 () const
int | getMarkerAlpha4 () const
int | getMarkerAlpha5 () const
int | getMarkerAlpha6 () const
int | getMarkerAlpha7 () const
int | getMarkerAlpha8 () const
int | getMarkerAlpha9 () const
QColor | getZoomerColor () const
QColor | getPaletteColor () const
int | getAxisLabelFontSize (int axisId) const
int | getYaxisLabelFontSize () const
int | getXaxisLabelFontSize () const
int | getAxesLabelFontSize () const

## Properties
int | intensity_color_map_type1
QColor | low_intensity_color
QColor | high_intensity_color
int | color_map_title_font_size
Properties inherited from DisplayPlot
QColor | line_color1
QColor | line_color2
QColor | line_color3
QColor | line_color4
QColor | line_color5
QColor | line_color6
QColor | line_color7
QColor | line_color8
QColor | line_color9
int | line_width1
int | line_width2
int | line_width3
int | line_width4
int | line_width5
int | line_width6
int | line_width7
int | line_width8
int | line_width9
Qt::PenStyle | line_style1
Qt::PenStyle | line_style2
Qt::PenStyle | line_style3
Qt::PenStyle | line_style4
Qt::PenStyle | line_style5
Qt::PenStyle | line_style6
Qt::PenStyle | line_style7
Qt::PenStyle | line_style8
Qt::PenStyle | line_style9
QwtSymbolStyle | line_marker1
QwtSymbolStyle | line_marker2
QwtSymbolStyle | line_marker3
QwtSymbolStyle | line_marker4
QwtSymbolStyle | line_marker5
QwtSymbolStyle | line_marker6
QwtSymbolStyle | line_marker7
QwtSymbolStyle | line_marker8
QwtSymbolStyle | line_marker9
int | marker_alpha1
int | marker_alpha2
int | marker_alpha3
int | marker_alpha4
int | marker_alpha5
int | marker_alpha6
int | marker_alpha7
int | marker_alpha8
int | marker_alpha9
QColor | zoomer_color
QColor | palette_color
int | yaxis_label_font_size
int | xaxis_label_font_size
int | axes_label_font_size

## Additional Inherited Members
Protected Slots inherited from DisplayPlot
virtual void | legendEntryChecked (QwtPlotItem *plotItem, bool on)
virtual void | legendEntryChecked (const QVariant &plotItem, bool on, int index)
Protected Attributes inherited from DisplayPlot
unsigned int | d_nplots
std::vector< QwtPlotCurve * > | d_plot_curve
QwtPlotPanner * | d_panner
QwtPlotZoomer * | d_zoomer
QwtDblClickPlotPicker * | d_picker
QwtPlotMagnifier * | d_magnifier
int64_t | d_numPoints
bool | d_stop
QList< QColor > | d_trace_colors
bool | d_autoscale_state

## Detailed Description

QWidget for displaying waterfall (spectrogram) plots.

## Constructor & Destructor Documentation

## ◆ WaterfallDisplayPlot()

WaterfallDisplayPlot::WaterfallDisplayPlot | ( | int | nplots,
|  | QWidget * | )

References setColorMapTitleFontSize().

Referenced by resetAxis(), and setFrequencyRange().

## ◆ ~WaterfallDisplayPlot()

WaterfallDisplayPlot::~WaterfallDisplayPlot | ( |  | ) |
| override

## Member Function Documentation

## ◆ clearData()

void WaterfallDisplayPlot::clearData | ( |  | ) |

References getMaxIntensity(), and getMinIntensity().

Referenced by getColorMapTitleFontSize().

## ◆ disableLegend

void WaterfallDisplayPlot::disableLegend | ( |  | ) |
| overrideslot

References setColorMapTitleFontSize().

Referenced by setNumRows().

## ◆ enableLegend [1/2]

void WaterfallDisplayPlot::enableLegend | ( |  | ) |
| slot

References setUserDefinedLowIntensityColor().

Referenced by setNumRows(), and updatedLowerIntensityLevel().

## ◆ enableLegend [2/2]

void WaterfallDisplayPlot::enableLegend | ( | bool | en | ) |
| slot

References setUserDefinedHighIntensityColor().

## ◆ getAlpha()

int WaterfallDisplayPlot::getAlpha | ( | unsigned int | which | ) |

References getColorMapTitleFontSize().

Referenced by getNumRows().

## ◆ getColorMapTitleFontSize()

int WaterfallDisplayPlot::getColorMapTitleFontSize | ( |  | ) | const

References clearData().

Referenced by getAlpha().

## ◆ getIntensityColorMapType()

int WaterfallDisplayPlot::getIntensityColorMapType | ( | unsigned int |  | ) | const

Referenced by getUserDefinedHighIntensityColor().

## ◆ getIntensityColorMapType1()

int WaterfallDisplayPlot::getIntensityColorMapType1 | ( |  | ) | const

References replot().

Referenced by getUserDefinedHighIntensityColor().

## ◆ getMaxIntensity()

double WaterfallDisplayPlot::getMaxIntensity | ( | unsigned int | which | ) | const

Referenced by clearData().

## ◆ getMinIntensity()

double WaterfallDisplayPlot::getMinIntensity | ( | unsigned int | which | ) | const

Referenced by clearData().

## ◆ getNumRows()

int WaterfallDisplayPlot::getNumRows | ( |  | ) | const

References getAlpha(), and setAlpha().

Referenced by setIntensityColorMapType().

## ◆ getStartFrequency()

double WaterfallDisplayPlot::getStartFrequency | ( |  | ) | const

References setFrequencyRange().

Referenced by plotNewData().

## ◆ getStopFrequency()

double WaterfallDisplayPlot::getStopFrequency | ( |  | ) | const

Referenced by plotNewData().

## ◆ getUserDefinedHighIntensityColor()

const QColor WaterfallDisplayPlot::getUserDefinedHighIntensityColor | ( |  | ) | const

References getIntensityColorMapType(), and getIntensityColorMapType1().

Referenced by setAlpha().

## ◆ getUserDefinedLowIntensityColor()

const QColor WaterfallDisplayPlot::getUserDefinedLowIntensityColor | ( |  | ) | const

Referenced by setAlpha().

## ◆ plotNewData() [1/2]

void WaterfallDisplayPlot::plotNewData | ( | const double * | dataPoints,
|  | const int64_t | numDataPoints,
|  | const double | timePerFFT,
|  | const gr::high_res_timer_type | timestamp,
|  | const int | droppedFrames )

References plotNewData().

## ◆ plotNewData() [2/2]

void WaterfallDisplayPlot::plotNewData | ( | const std::vector< const double * > | dataPoints,
|  | const int64_t | numDataPoints,
|  | const double | timePerFFT,
|  | const gr::high_res_timer_type | timestamp,
|  | const int | droppedFrames )

References getStartFrequency(), getStopFrequency(), and plotNewData().

Referenced by plotNewData(), and plotNewData().

## ◆ replot()

void WaterfallDisplayPlot::replot | ( | void |  | ) |
| overridevirtual

Implements DisplayPlot.

References setIntensityRange().

Referenced by getIntensityColorMapType1().

## ◆ resetAxis()

void WaterfallDisplayPlot::resetAxis | ( |  | ) |

References WaterfallDisplayPlot().

Referenced by setFrequencyRange().

## ◆ setAlpha()

void WaterfallDisplayPlot::setAlpha | ( | unsigned int | which,
|  | int | alpha )

References getUserDefinedHighIntensityColor(), and getUserDefinedLowIntensityColor().

Referenced by getNumRows().

## ◆ setColorMapTitleFontSize

void WaterfallDisplayPlot::setColorMapTitleFontSize | ( | int | tfs | ) |
| slot

Referenced by disableLegend(), and WaterfallDisplayPlot().

## ◆ setFrequencyRange()

void WaterfallDisplayPlot::setFrequencyRange | ( | const double | ,
|  | const double | ,
|  | const double | units = 1000.0,
|  | const std::string & | strunits = "kHz" )

References resetAxis(), and WaterfallDisplayPlot().

Referenced by getStartFrequency().

## ◆ setIntensityColorMapType

void WaterfallDisplayPlot::setIntensityColorMapType | ( | const unsigned int | ,
|  | const int | ,
|  | const QColor | ,
|  | const QColor | )
| slot

References getNumRows().

Referenced by setUserDefinedHighIntensityColor().

## ◆ setIntensityColorMapType1

void WaterfallDisplayPlot::setIntensityColorMapType1 | ( | int |  | ) |
| slot

Referenced by setPlotPosHalf().

## ◆ setIntensityRange()

void WaterfallDisplayPlot::setIntensityRange | ( | const double | minIntensity,
|  | const double | maxIntensity )

Referenced by replot().

## ◆ setNumRows

void WaterfallDisplayPlot::setNumRows | ( | int | nrows | ) |
| slot

References disableLegend(), enableLegend(), and setPlotPosHalf().

Referenced by updatedUpperIntensityLevel().

## ◆ setPlotPosHalf

void WaterfallDisplayPlot::setPlotPosHalf | ( | bool | half | ) |
| slot

References setIntensityColorMapType1().

Referenced by setNumRows().

## ◆ setUserDefinedHighIntensityColor

void WaterfallDisplayPlot::setUserDefinedHighIntensityColor | ( | QColor |  | ) |
| slot

References setIntensityColorMapType().

Referenced by enableLegend().

## ◆ setUserDefinedLowIntensityColor

void WaterfallDisplayPlot::setUserDefinedLowIntensityColor | ( | QColor |  | ) |
| slot

Referenced by enableLegend().

## ◆ updatedLowerIntensityLevel

void WaterfallDisplayPlot::updatedLowerIntensityLevel | ( | const double |  | ) |
| signal

References enableLegend().

Referenced by updatedUpperIntensityLevel().

## ◆ updatedUpperIntensityLevel

void WaterfallDisplayPlot::updatedUpperIntensityLevel | ( | const double |  | ) |
| signal

References setNumRows(), updatedLowerIntensityLevel(), and updatedUpperIntensityLevel().

Referenced by updatedUpperIntensityLevel().

## Property Documentation

## ◆ color_map_title_font_size

int WaterfallDisplayPlot::color_map_title_font_size
| readwrite

## ◆ high_intensity_color

QColor WaterfallDisplayPlot::high_intensity_color
| readwrite

## ◆ intensity_color_map_type1

int WaterfallDisplayPlot::intensity_color_map_type1
| readwrite

## ◆ low_intensity_color

QColor WaterfallDisplayPlot::low_intensity_color
| readwrite

The documentation for this class was generated from the following file:

- WaterfallDisplayPlot.h